import 'package:flutter/material.dart';

class BrandColors {
  static const BrandPalette dark = BrandPalette(
      accent: Color(0xFFE74C3C),
      accentVibrant: Color(0xFFFA3031),
      root: Color(0xFF222222),
      tile: Color(0xFF2C2C2C),
      sheet: Color(0xFF222222),
      foreColor: Color(0xFFE5E5E5),
      defaultIcon: Color(0xFFE5E5E5),
      darkerIcon: Colors.white,
      secondaryText: Color(0xFFADADAD),
      devices: DeviceCategoryColorPalette(
        xboxGreen: Color(0xFF7EB903),
        psBlue: Color(0xFF2196F3),
        nintendoRed: Color(0xFFE60012),
        controllerYellow: Color(0xFFFFEA00),
        wearablePurple: Color(0xFFAB47BC),
        vrOrange: Color(0xFFFF5722),
        miscPink: Color(0xFFFF79B0),
        headphoneTeal: Color(0xFF009688),
      ),
      stages: StageColorPalette(
        stageWarranty: Color(0xFFDC182C),
        stageConfirmationSent: Color(0xFF43A047),
        stageConsoleReceived: Color(0xFF2196F3),
        stageConsoleRepaired: Color(0xFF1976D2),
        stageConsoleTested: Color(0xFF9EE05C),
        stageFailedTesting: Color(0xFFDC182C),
        stageConsolePosted: Color(0xFF3F51B5),
        stageInvoiced: Color(0xFFB954C4),
        stageCancelled: Color(0xFFC91D18),
        stageQuarantine: Color(0xFFF2F20D),
        stageYmProcessing: Color(0xFFF2F20D),
        stageOnHold: Color(0xFFF2F20D),
        stageBer: Color(0xFFF2A20D),
        stageDefault: Color(0xFF2196F3),
      )
  );

  static const BrandPalette light = BrandPalette(
      accent: Color(0xFFE74C3C),
      accentVibrant: Color(0xFFFA3031),
      root: Color(0xFFF4F4F4),
      tile: Color(0xFFFFFFFF),
      sheet: Color(0xFFFFFFFF),
      foreColor: Color(0xFF232F34),
      defaultIcon: Color(0xFF666666),
      darkerIcon: Color(0xFF232F34),
      secondaryText: Color(0xFF727f89),
      devices: DeviceCategoryColorPalette(
          xboxGreen: Color(0xFF107C10),
          psBlue: Color(0xFF003791),
          nintendoRed: Color(0xFFE60012),
          controllerYellow: Color(0xFFEBDA26),
          wearablePurple: Color(0xFFAB47BC),
          vrOrange: Color(0xFFFF8A65),
          miscPink: Color(0xFFFF79B0),
          headphoneTeal: Color(0xFF009688),
      ),
      stages: StageColorPalette(
          stageWarranty: Color(0xFFF1192E),
          stageConfirmationSent: Color(0xFFB1FFA2),
          stageConsoleReceived: Color(0xFFB5B8ED),
          stageConsoleRepaired: Color(0xFF6369E2),
          stageConsoleTested: Color(0xFF60A917),
          stageFailedTesting: Color(0xFFF1192E),
          stageConsolePosted: Color(0xFF1F2374),
          stageInvoiced: Color(0xFFA435B1),
          stageCancelled: Color(0xFFF1192E),
          stageQuarantine: Color(0xFFFFFF00),
          stageYmProcessing: Color(0xFFFFFF00),
          stageOnHold: Color(0xFFFFFF00),
          stageBer: Color(0xFFFFA500),
          stageDefault: Color(0xFF6473E1),
      )
  );
}

class BrandPalette {
  final Color accent;
  final Color accentVibrant;
  final Color root;
  final Color tile;
  final Color sheet;
  final Color foreColor;
  final Color defaultIcon;
  final Color darkerIcon;
  final Color secondaryText;
  final DeviceCategoryColorPalette devices;
  final StageColorPalette stages;

  const BrandPalette({
    required this.accent,
    required this.accentVibrant,
    required this.root,
    required this.tile,
    required this.sheet,
    required this.foreColor,
    required this.defaultIcon,
    required this.darkerIcon,
    required this.secondaryText,
    required this.devices,
    required this.stages
  });
}

class StageColorPalette {
  final Color stageWarranty;
  final Color stageConfirmationSent;
  final Color stageConsoleReceived;
  final Color stageConsoleRepaired;
  final Color stageConsoleTested;
  final Color stageFailedTesting;
  final Color stageConsolePosted;
  final Color stageInvoiced;
  final Color stageCancelled;
  final Color stageQuarantine;
  final Color stageYmProcessing;
  final Color stageOnHold;
  final Color stageBer;
  final Color stageDefault;

  const StageColorPalette({
    required this.stageWarranty, 
    required this.stageConfirmationSent, 
    required this.stageConsoleReceived, 
    required this.stageConsoleRepaired,
    required this.stageConsoleTested,
    required this.stageFailedTesting,
    required this.stageConsolePosted,
    required this.stageInvoiced,
    required this.stageCancelled,
    required this.stageQuarantine,
    required this.stageYmProcessing,
    required this.stageOnHold,
    required this.stageBer,
    required this.stageDefault
  });
}

class DeviceCategoryColorPalette {
  final Color xboxGreen;
  final Color psBlue;
  final Color nintendoRed;
  final Color controllerYellow;
  final Color wearablePurple;
  final Color vrOrange;
  final Color miscPink;
  final Color headphoneTeal;

  const DeviceCategoryColorPalette({
    required this.xboxGreen,
    required this.psBlue,
    required this.nintendoRed,
    required this.controllerYellow,
    required this.wearablePurple,
    required this.vrOrange,
    required this.miscPink,
    required this.headphoneTeal
  });
}