extension NumBerExtensions<T extends num> on T {
  bool between(num min, num max) {
    assert(min <= max, 'Invalid bounds: $min and $max, min cannot be greater than max');
    return min <= this && this < max;
  }

  /// Returns `true` if this number is outside the given range of [min] (exclusive) and
  /// [max] (exclusive).
  bool outside(num min, num max) {
    assert(min <= max, 'Invalid bounds: $min and $max, min cannot be greater than max');
    return this < min || this > max;
  }
}