extension StringExtensions on String? {
  bool isNullOrEmpty() => this?.isEmpty ?? true;

  String emptyIfNull() => this ?? "";

  String defaultIfEmpty({String defaultVal = ""}) => isNullOrEmpty() ? defaultVal : this!;

  String? capitalize() => isNullOrEmpty() ? this : '${this![0].toUpperCase()}${this!.substring(1)}';

  bool equalsIgnoreCase(String? lookup) {
    return this?.toLowerCase() == lookup?.toLowerCase();
  }

  bool containsIgnoreCase(String? lookup) {
    return lookup != null && this!.toLowerCase().contains(lookup.toLowerCase());
  }

  String truncateWithEllipsis(int maxLength) {
    if (this == null || this!.length <= maxLength) return this ?? '';
    return '${this!.substring(0, maxLength - 3)}...';
  }
}