import 'package:consoledoctor_common/src/extensions/string_extensions.dart';
import 'package:consoledoctor_common/src/helpers/validation_utils.dart';

extension StringValidationExtensions on String? {

  bool isValidOrderID() => !isNullOrEmpty() && ValidationUtils.orderIDRegex.hasMatch(this!);
  bool isValidDGOrderID() => !isNullOrEmpty() && ValidationUtils.dgOrderIDRegex.hasMatch(this!);
  bool isValidCDOrderID() => !isNullOrEmpty() && ValidationUtils.cdOrderIDRegex.hasMatch(this!);

  bool isDPDTracking() => !isNullOrEmpty() && ValidationUtils.dpdTrackingRegex.hasMatch(this!);
  bool isDPDBarcode() => !isNullOrEmpty() && ValidationUtils.dpdBarcodeRegex.hasMatch(this!);
  bool isDPDTrackingOrBarcode() => isDPDTracking() || isDPDBarcode();

  bool isValidPhoneNumber() => !isNullOrEmpty() && ValidationUtils.phoneNumberRegex.hasMatch(this!);
  bool isValidMobileNumber() => !isNullOrEmpty() && ValidationUtils.mobileNumberRegex.hasMatch(this!);
  bool isValidEmail() => !isNullOrEmpty() && ValidationUtils.emailRegex.hasMatch(this!);

}